import 'websocket-polyfill';
import { EventEmitter } from './emitter.js';
import { Event, EventTemplate, Filter, SimplePool, Sub, UnsignedEvent } from 'nostr-tools';
import { SocketConfig, SocketOptions } from './config.js';
export declare class NostrSocket extends EventEmitter {
    readonly _pool: SimplePool;
    readonly _pubkey: string;
    readonly _signer: Signer;
    readonly filter: Filter;
    readonly relays: string[];
    readonly opt: SocketOptions;
    _cipher?: string;
    _sub: Sub;
    constructor(signer: Signer, pubkey: string, relays: string[], config?: SocketConfig);
    set cipher(secret: string | undefined);
    get pool(): SimplePool;
    get pubkey(): string;
    get template(): EventTemplate;
    _echoHandler(event: Event): boolean;
    _eventHandler(event: Event): Promise<void>;
    pub(eventName: string, payload: any, template?: Partial<EventTemplate>): Promise<import("nostr-tools").Pub>;
    sub(filter: Filter): Sub<import("nostr-tools").Kind>;
}
export declare class Signer {
    static generate(): Signer;
    readonly _secret: string;
    constructor(secret: string);
    getPublicKey(): Promise<string>;
    signEvent(event: UnsignedEvent): Promise<{
        id: string;
        sig: string;
        kind: import("nostr-tools").Kind;
        tags: string[][];
        content: string;
        created_at: number;
        pubkey: string;
    }>;
}
//# sourceMappingURL=index.d.ts.map